---
apiVersion: v1
kind: Namespace
metadata:
  name: ${CI_PROJECT_NAMESPACE}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
---
# ----- Service -----
apiVersion: v1
kind: Service
metadata:
  name: ${CI_PROJECT_NAME}
  namespace: ${CI_PROJECT_NAMESPACE}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
  labels:
    app: ${CI_PROJECT_NAME}
spec:
  ports:
    - protocol: TCP
      name: web
      port: 80
      targetPort: 8080
  selector:
    app: ${CI_PROJECT_NAME}
---
# ----- Deployment -----
kind: Deployment
apiVersion: apps/v1
metadata:
  name: ${CI_PROJECT_NAME}
  namespace: ${CI_PROJECT_NAMESPACE}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
  labels:
    app: ${CI_PROJECT_NAME}
spec:
  replicas: 1
  selector:
    matchLabels:
      app: ${CI_PROJECT_NAME}
  template:
    metadata:
      labels:
        app: ${CI_PROJECT_NAME}
    spec:
      containers:
        - name: ${CI_PROJECT_NAME}
          image: ${DOCKER_USER}/${CI_PROJECT_NAME}:${CI_COMMIT_SHORT_SHA}
          ports:
            - name: web
              containerPort: 8080
          resources:
            limits:
              cpu: "1"
              memory: "128Mi"
            requests:
              cpu: "1"
              memory: "128Mi"
---
apiVersion: traefik.containo.us/v1alpha1
kind: IngressRoute
metadata:
  name: ${CI_PROJECT_NAME}
  namespace: ${CI_PROJECT_NAMESPACE}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
  labels:
    app: ${CI_PROJECT_NAME}
spec:
  entryPoints:
    - web
  routes:
  - match: Host(`${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}.127.0.0.1.nip.io`)
    kind: Rule
    services:
    - name: ${CI_PROJECT_NAME}
      port: 80
